/* compile with:
 *     cl /W3 /c bug.cpp
 *
 * This is a bug in the header files that ship with VC++ v5.x.
 * objbase.h claims that you can use CINTERFACE to get C-style
 * definitions even when compiling with C++. Unfortunately,
 * other VC++ header files don't contain the necessary references
 * to CINTERFACE to make this work. In fact, CINTERFACE can't
 * *ever* work, since the definition of REFIID in wtypes.h
 * does not obey the CINTERFACE macro!
 *
 * The following code demonstrates the problem. The compiler will
 * refuse to compile, complaining that the first argument being
 * passed to memcmp() is a structure, rather than a pointer. That's
 * because wtypes.h ends up defining REFIID as "const IID &",
 * when it should have defined it as "const IID * const".
 */

#define  CINTERFACE
#include <objbase.h>
#include <string.h>
HRESULT STDMETHODCALLTYPE   TUnknownQueryInterface(
    IUnknown* This, REFIID Type, LPVOID* Object);
ULONG STDMETHODCALLTYPE     TUnknownAddRef(IUnknown* This);
ULONG STDMETHODCALLTYPE     TUnknownRelease(IUnknown* This);

IUnknownVtbl    VUnknown    =
    {
    TUnknownQueryInterface,
    0,
    0,
    };


HRESULT STDMETHODCALLTYPE   TUnknownQueryInterface(
    IUnknown* This, REFIID Type, LPVOID* Object)
    {
    HRESULT Result  = S_OK;

    if(!memcmp(Type, &IID_IUnknown, sizeof(IID_IUnknown)))
        *Object = This;
    else
        Result  = E_NOINTERFACE;
    return Result;
    }
    
