@echo off
rem  =========================================================
rem  Batch file to compile the "scrntest" SDI application.
rem  =========================================================

rem  The call to vcvars32.bat sets up the PATH, INCLUDE and LIB variables
rem  for command line compilation using VC++. Change the path to the batch
rem  file if your path is different. (vcvars32.bat is installed as part of
rem  the VC++ installation, and may already be called from your
rem  autoexec.bat file. If it is, comment out the next line.)

call "C:\Program Files\DevStudio\VC\bin\vcvars32.bat"

rem  This batch file assumes that the application files are in the
rem  default places used by AppWizard when generating a "scrntest"
rem  application. The C++ file names are shortened to comply with
rem  the 8.3 requirement for DOS files. The six .cpp files, seven .h files
rem  and scrntest.rc should be in \scrntest, and the four resource files
rem  (scrntDoc.ico, scrntest.ico, scrntest.rc2 and Toolbar.bmp) should be
rem  in \scrntest\res.
rem  The output files are written to \scrntest\release.

cd\scrntest
if not exist release\nul mkdir release

set CL=/nologo /MD /W4 /GX /O2 /D"WIN32" /D"NDEBUG" /D"_WINDOWS" /D"_AFXDLL" /Fo"Release/" /Fd"Release/" /FD /c

echo.
echo Compiling resources (scrntest.rc)...

rc /l 0x409 /fo"./release/scrntest.res" /d "NDEBUG" /d "_AFXDLL" scrntest.rc

echo.
echo Compiling cpp files...

cl scrntest.cpp mainfrm.cpp scrntdoc.cpp scrnview.cpp fullscrn.cpp stdafx.cpp

echo.
echo Linking...

cd release
link /out:"scrntest.exe" /subsystem:windows /pdbtype:sept Fullscrn.obj MainFrm.obj scrntDoc.obj scrntest.obj scrntest.res scrnView.obj StdAfx.obj
cd..

set CL=

echo.
echo Done!
